-------------------------------------------------------------------------------
-- Filename:   slot_counter.vhd
-- History:
--   2006-7-14     First Version
-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity slot_counter is
  generic (
    C_CNT_WIDTH : integer := 4
  );

  port (
    SYS_CLK : in  std_logic;
    SYS_RST : in  std_logic;
    count   : out std_logic_vector(0 to C_CNT_WIDTH-1)
  );
end slot_counter;

architecture imp of slot_counter is

  signal count_w : std_logic_vector(0 to C_CNT_WIDTH-1);
  
begin

  process(SYS_CLK)
  begin
    if SYS_CLK'event and SYS_CLK = '1' then
      if SYS_RST = '1' then
        count_w <= (others => '0');
      else
        count_w <= count_w + 1;
      end if;
    end if;
  end process;

  count <= count_w;

end imp;
